<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Example 1</TITLE>
<link href="suifmath_20.html" rel=Next>
<link href="suifmath_18.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_18.html">previous</A>, <A HREF="suifmath_20.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC19" HREF="suifmath_toc.html#TOC19">Example: An Implementation of include_for()</A></H2>
<P>
<A NAME="IDX446"></A>
<A NAME="IDX447"></A>
<A NAME="IDX448"></A>

</P>
<P>
The following procedure will take a <CODE>tree_for</CODE> as an argument and
will produce a system of inequalities (a <CODE>named_lin_ineq</CODE>) that
represent the iteration space of the loop.

</P>


<PRE>
named_lin_ineq * include_for(tree_for * tf)
{
    // the index variable name
    immed idx(tf-&#62;index());

    // Find the lower bound
    // create an array_info class to extract linear function of the bounds
    array_info * lb_ai = new array_info;
    append_to_list(lb_ai, tf-&#62;lb_op(), tf, io_max, TRUE);
    named_lin_ineq * cl;
    // convert the bounds to named linear inequality class 
    cl  = named_lin_ineq::mk_named_lin_ineq(lb_ai, idx, TRUE); 
    if(cl == NULL) {
        printf("Unknown lower bound\n");
        return NULL;
    }

    // Find the upper bound
    array_info * ub_ai = new array_info;
    append_to_list(ub_ai, tf-&#62;ub_op(), tf, io_min, TRUE);
    named_lin_ineq * cu;
    cu  = named_lin_ineq::mk_named_lin_ineq(*ub_ai, idx, FALSE);
    if(cu == NULL) {
        printf("Unknown upper bound\n");
        delete cl;
        return NULL;
    }
    
    //  add the lower bound and upper bound togther 
    cu = named_lin_ineq::and(cl, cu, 0, 1);
    
    // Find the step
    access_vector * stp_av = new access_vector(tf-&#62;step_op(), tf, TRUE);
    named_lin_ineq * stp;
    stp = named_lin_ineq::mk_named_lin_ineq(stp_av, idx, FALSE);
    boolean stpbad = TRUE;
    if(stp)                                           // check bad step size
        if((stp-&#62;n() == 2)&#38;&#38;                          // no sym variables
           (stp-&#62;ineqs().m() == 1))                    // no max or mins 
            if(stp-&#62;ineqs()[0][0] == 1)                // nont step
               stpbad = FALSE;

    if(stpbad) {
        printf("Unknown or non-unit step size\n");
        delete cl;
        delete cu;
        if(stp) delete stp;
        return NULL;
    }
    
    cu-&#62;cleanup();
    
    delete cl;
    delete stp;

    return cu;
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_18.html">previous</A>, <A HREF="suifmath_20.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
